
'the old 3D Example with texturepolygones
'it runs with the included version of GDK.
'all vars must be dim before you can use it
'----------------------------------------------------

$include "gdk.h" '[G]ame [D]eveloper [K]it
defint a-z

%pa=27:%fa=17

dim xoo(%pa) 		as shared integer	'original object data base
dim yoo(%pa) 		as shared integer
dim zoo(%pa) 		as shared integer
dim xo(%pa) 		as shared integer   'object points behind scale
dim yo(%pa) 		as shared integer
dim zo(%pa) 		as shared integer
dim xr(%pa)  		as shared integer   'object points behind transfom
dim yr(%pa)  		as shared integer
dim zr(%pa)  		as shared integer
dim xb(%pa)  		as shared integer   'object points behind perspektive
dim yb(%pa)  		as shared integer
dim zb(%pa)  		as shared integer
dim fl(%fa,3) 		as shared integer   'sharps wi 4 vertix
dim fltx(%fa,3) 	as shared integer   'texture positon in plane.pcx * 5
dim flty(%fa,3)     as shared integer
dim fc(%fa,3)       as shared integer	'for MakeColor
dim fs(%fa)			as shared integer   'sorted shapes
dim co(360)			as shared single    'floatingpoint sinus and cosinus
dim si(360)         as shared single
dim w				as shared single
dim xp(3) 			as shared integer   'shape point before painting
dim yp(3) 			as shared integer
dim tx(3) 			as shared integer   'texture points before painting
dim ty(3) 			as shared integer
dim d				as shared integer   'sinus counter for background
dim t				as shared string    'string for inkey$
dim x				as shared integer   'for read data loops
dim y				as shared integer
dim z 				as shared integer

dim texture(31*320) as shared byte	    'the first 30 lines from PCX-plane texture
dim texSEG			as shared word      'pointer of textures
dim texOFF			as shared word
dim buffer(32000)  	as shared integer	'the videopage two with 64000 byte / pixel
dim bufSEG			as shared word      'pointer of videopage two
dim bufOFF			as shared word
dim ErrorFlag 		as shared integer   'returncode from sub's
dim pcx				as shared string    'pcx-filename
dim OldMode			as shared integer   'current videomode

dim sec as integer
dim sf as single
dim xf as integer
dim yf as integer
dim zf as integer

'prototypes in mainprog
'----------------------
declare sub winkeltab()
declare sub makelinepoly()
declare sub makesolidpoly()
declare sub makecolorpoly()
declare sub maketexturepoly()

declare sub scale(byval s as single)
declare sub rotation(byval xw as integer,byval yw as integer,byval zw as integer)
declare sub sortpoly()
declare sub transform(byval xp as integer,byval yp as integer,byval zp as integer)
declare sub perspektive()
declare function infront(byval f as integer) as integer

declare sub infotext()

'Get segment and offset adress in word's (??)
'--------------------------------------------------
texSEG=varseg(texture(0)):texOFF=varptr(texture(0))
bufSEG= varseg(buffer(0)):bufOFF= varptr(buffer(0))

'Create floatingpoints values
WinkelTab


'Object database
'---------------
Object:

data -10, 0,-1
data -10, 0, 1
data  -1, 0, 1
data  -1, 0,-2
data   1, 0,-2
data   1, 0, 1
data  10, 0, 1
data  10, 0,-1

data  -1,-2,-4
data  -1, 0,-4
data  -1, 0, 3
data  -1,-2, 3

data  -1, 0, 9
data  -1,-1, 9

data   1,-1, 9
data   1, 0, 9
data   1, 0, 3
data   1,-2, 3

data   1, 0,-4
data   1,-2,-4

data  -3,-1, 8
data  -3,-1, 9
data  -1, 0, 9
data  -1, 0, 7

data   1, 0, 7
data   1, 0, 9
data   3,-1, 9
data   3,-1, 8

restore Object
for i=0 to %pa
	read xoo(i),yoo(i),zoo(i)
next

'Shape database
'--------------
Flaechen:
data  0, 1, 2, 3
data  3, 2, 1, 0
data  4, 5, 6, 7
data  7, 6, 5, 4
data  8, 9,10,11

data 14,15,16,17
data 11,10,12,13
data 17,16,18,19
data 13,12,15,14
data 19,18, 9, 8

data 10,16,15,12
data  9,18,16,10

data 19,8,11,17
data 17,11,13,14

data 20,21,22,23
data 23,22,21,20
data 24,25,26,27
data 27,26,25,24

restore Flaechen
for i=0 to %fa
	for z=0 to 3
    	read fl(i,z)
    next
next

'Texture database
'----------------
Texturen:
data  0, 1,  0, 3,  9, 3,  9, 0
data  9, 3,  9, 6,  0, 6,  0, 4
data  9, 0,  9, 3, 18, 3, 18, 1
data 18, 4, 18, 6,  9, 6,  9, 3
data 18, 1, 18, 3, 25, 3, 25, 1
data 18, 5, 18, 6, 24, 6, 24, 4
data 25, 1, 25, 3, 31, 3, 31, 2
data 24, 4, 24, 6, 31, 6, 31, 4
data 31, 2, 31, 3, 33, 3, 33, 2
data 31, 4, 31, 6, 33, 6, 33, 4
data 33, 0, 33, 2, 39, 2, 39, 0
data 39, 0, 39, 2, 46, 2, 46, 0
data 52, 0, 52, 2, 59, 2, 59, 0
data 46, 0, 46, 2, 52, 2, 52, 0
data 34, 5, 34, 6, 36, 6, 36, 4
data 42, 4, 42, 6, 40, 6, 40, 5
data 37, 4, 37, 6, 39, 6, 39, 5
data 45, 5, 45, 6, 43, 6, 43, 4

restore Texturen
for i=0 to %fa
	for z=0 to 3
    	read x:fltx(i,z)=x*5 'positions in plane.pcx (*5)
        read y:flty(i,z)=y*5
    next
next

'Load the first 30 Lines from plane.PCX in Texturebuffer texSEG:texOFF
'path and name from pcx-file
'---------------------------
pcx$="plane.pcx"

'is it an real pcx-file ?
'------------------------
if ifPCX(pcx$,ErrorFlag%) then

    'Fill the PCXHeader (see GDK.H)
    '------------------------------
    if GetPCXHeader(pcx$,ErrorFlag) then
        'is it an picture with 256 color and 320x200 pixel than load it
        '--------------------------------------------------------------
		LoadPCX pcx$,texSEG,texOFF,0,0,29 'the first 30 lines
    else
     	beep:?"PCX File is not an Gametool resource! ERROR:";ErrorFlag
      	End
    end if
else
	beep:?"PCX file not found! ERROR:";ErrorFlag:End
end if




'Load a new colortab in memory
'-----------------------------
gLoadColorPal "game.pal"

'Save the current VideoMode
'--------------------------
OldMode=gGetVideoMode

'Set mode &H13 with 256 colors and 320x200 pixels
'------------------------------------------------
gSetVideoMode &h13

'Set the colortab
'----------------
gSetColorPal

'clear the global vars
'---------------------
y=0:x=180:z=0:xf=0:yf=0:zf=0:sec=0:sf=5

'main loop
'---------
mainloop:
	while not instat
        select case t$
            case "q","Q"
            	goto AppEnde
        	case "y"
            	incr y,2:if y>358 then y=0
			case "Y"
            	decr y,2:if y<0 then y=359
            case "x"
            	incr x,2:if x>358 then x=0
       	 	case "X"
            	decr x,2:if x<0 then x=359
			case "z"
            	incr z,2:if z>358 then z=0
       	 	case "Z"
            	decr z,2:if z<0 then z=359
            case "+","."
            	incr sf,0.1:if sf>13 then sf=13.0
       	 	case "-",","
            	decr sf,0.1:if sf<1 then sf=1.0
            case "t","T"
            	incr sec:if sec>3 then sec=0
            case "h","H"
                InfoText
        end select
        t$=""

    	Scale sf
		Rotation x,y,z
    	Transform xf,yf,zf-160
    	Perspektive
        SortPoly
        select case sec
            case 0,2
        	MakeTexturePoly
            case 1
            MakeSolidPoly
            case 3
            MakeColorPoly
        end select
        wend:t$=inkey$
goto mainloop


AppEnde:
'Set the old VideoMode
'---------------------
gSetVideoMode OldMode

'The end
'-------
end

sub infotext()
gSetVideoMode OldMode
cls
print "ROTATION   ZOOM   CHANGEPOLY   QUIT    HELP"
print "--------------------------------------------"
print "x or X    + or -    c or C    q or Q  h or H"
print "y or Y    , or .    p or P "
print "z or Z"
print
print
print "In eigener Sache"
print "Wer hat Zeit und Lust mit mir ein Handbuch in Deutsch/English fr das"
print "GDK ([G]ame [D]eveloper [K]it) zu schreiben ? Wenn Du aus dem Raum NRW"
print "kommst und Lust auf SOUND,DSP,DMA,SPRITES,VESA,TEXTUREN,PLASMA,SCROLLING"
print "FIRE,3D usw. mit PowerBASIC hast dann la uns Spa haben."
print
print "B.E.K. Computer D.J.Peters Tel: 0201 / 48 84 06 o. 0201 / 48 54 26"
print "------------------------------------------------------------------"
print "BTX              :0201488406 0001"
print "INTERNET eMail   :BEK-Computer@t-online.de oder 0201488406-1@t-online.de"
print "FAX              :0201 / 48 84 06"
print
print "press a key ..."
while not instat:wend
gSetVideoMode &h13
gSetColorPal
end sub





'main sub's and functions
'------------------------
sub makelinepoly
    dim i as local integer
    dim z as local integer

    'clear the videopage two 64000 byte in words col1,col2 = one word
    '----------------------------------------------------------------
    gFill bufSEG,bufOFF,32000,%blau+5,%blau+5
	gFill bufSEG,bufOFF+32000,32000,%gruen-5,%gruen-5
	for i=0 to %fa
        'can you see the shape (the frontface)
        if InFront(fs(i)) THEN
			for z=0 to 3
    			xp(z)=xb(fl(fs(i),z)) 'array with 4 points
        		yp(z)=yb(fl(fs(i),z))
    		next
            'draw the shape as frame in videopage two
            for z=0 to 2
    			gLine bufSEG,bufOFF,xp(z),yp(z),xp(z+1),yp(z+1),%grau+fs(i)*20
            next
            gLine bufSEG,bufOFF,xp(z),yp(z),xp(0),yp(0),%grau+fs(i)*20
        end if
	next
    sync 'waiting of raytrace
    'fill the shining videopage (one) with page 2 320x200 pixel
    '----------------------------------------------------------
    gCopyUp bufSEG,bufOFF,&ha000,0, 0,0, 0,0, 320,200
end sub


sub makesolid
    dim i as local integer
    dim z as local integer

    gFill bufSEG,bufOFF,32000,%blau+5,%blau+5
	gFill bufSEG,bufOFF+32000,32000,%gruen-5,%gruen-5

	for i=0 to %fa
        if InFront(fs(i)) THEN
			for z=0 to 3
    			xp(z)=xb(fl(fs(i),z))
        		yp(z)=yb(fl(fs(i),z))
    		next
            'draw the shape as solid polygone
            '--------------------------------
    		gFillPoly bufSEG??,bufOFF??,xp(),yp(),3,%grau+fs(i)*20
        end if
	next
    sync
    gCopyUp bufSEG,bufOFF,&ha000,0, 0,0, 0,0, 320,200
end sub


sub makesolidpoly
    dim i as local integer
    dim z as local integer

    gFill bufSEG,bufOFF,32000,%blau+5,%blau+5
	gFill bufSEG,bufOFF+32000,32000,%gruen-5,%gruen-5

	for i=0 to %fa
        if InFront(fs(i)) THEN
			for z=0 to 3
    			xp(z)=xb(fl(fs(i),z))
        		yp(z)=yb(fl(fs(i),z))
    		next
            'draw the shape as solid polygone
            '--------------------------------
    		gFillSolidPoly bufSEG??,bufOFF??,xp(),yp(),3,%grau+fs(i)*20
        end if
	next
    sync
    gCopyUp bufSEG,bufOFF,&ha000,0, 0,0, 0,0, 320,200
end sub

sub makecolorpoly
    dim i as local integer
    dim z as local integer

    gFill bufSEG,bufOFF,32000,%blau+5,%blau+5
	gFill bufSEG,bufOFF+32000,32000,%gruen-5,%gruen-5

	for i=0 to %fa
        if InFront(fs(i)) THEN
			for z=0 to 3
    			xp(z)=xb(fl(fs(i),z))
        		yp(z)=yb(fl(fs(i),z))
    		next
            'fill the texture array with colors
            tx(0)= 0+(fs(i)\2)*20
            tx(1)=19+(fs(i)\2)*20
            tx(2)=19+(fs(i)\2)*20
            tx(3)= 0+(fs(i)\2)*20

            'draw the shape as color polygone
            '--------------------------------
    		gFillColorPoly bufSEG,bufOFF,xp(),yp(),3,tx()
        end if
	next
    sync
    gCopyUp bufSEG,bufOFF,&ha000,0, 0,0, 0,0, 320,200
end sub


sub maketexturepoly
    dim i as local integer
    dim z as local integer
    dim zm as local integer

    gFill bufSEG,bufOFF,32000,%blau+5,%blau+5
	gFill bufSEG,bufOFF+32000,32000,%gruen-5,%gruen-5

	for i=0 to %fa
        if InFront(fs(i)) THEN

            zm=0

			for z=0 to 3
    			xp(z)=xb(fl(fs(i),z))
        		yp(z)=yb(fl(fs(i),z))
                if    zr(fl(fs(i),z))>=0 then incr zm
                'fill the texture array with texturepositions in pcx-file
                tx(z)=fltx (fs(i),z)
                ty(z)=flty (fs(i),z)
    		next
            if zm<3 then
            'draw the shape as texture polygone
            '----------------------------------
    		gFillTexturePoly bufSEG,bufOFF,xp(),yp(),3,199,texSEG,texOFF,tx(),ty()
            end if
        end if
	next
    sync
    gCopyUp bufSEG,bufOFF,&ha000,0, 0,0, 0,0, 320,200
end sub

'scale all original objectpoints
sub Scale(byval s as single)
    dim i as local integer
	for i=0 to %pa
    	xo(i)=xoo(i)*s!
        yo(i)=yoo(i)*s!
        zo(i)=zoo(i)*s!
    next
end sub

'rotate all scaled object points
sub Rotation(byval xw as integer,byval yw as integer,byval zw as integer)
    dim i as local integer
    dim x as local integer
    dim y as local integer
    dim z as local integer

    dim cox as local single
    dim coy as local single
    dim coz as local single
    dim six	as local single
    dim siy as local single
    dim siz as local single

    'opzimize the speed
    cox!=co!(xw):coy!=co!(yw):coz!=co!(zw)
    six!=si!(xw):siy!=si!(yw):siz!=si!(zw)

    for i=0 to %pa

    	y		= yo(i)*cox!-zo(i)*six!
    	z		= yo(i)*six!+zo(i)*cox!

        x		= xo(i)*coy!+z*siy!
        zr(i)	=-xo(i)*siy!+z*coy!

        xr(i)	= x*coz!-y*siz!
        yr(i)	= x*siz!+y*coz!

    next
end sub

'move the object in the 3D room
sub Transform(byval xp as integer,byval yp as integer,byval zp as integer)
    dim i as local integer
    for i=0 to %pa
        xr(i)=xr(i)+xp
		yr(i)=yr(i)+yp
		zr(i)=zr(i)+zp
    next
end sub


sub Perspektive
    dim i as local integer
    for i=0 to %pa

    	xb(i)=128*xr(i)/zr(i)+159
        yb(i)=128*yr(i)/zr(i)+99
    next

end sub

'can you see the current shape (frontside to observer)
function InFront(byval f as integer) as integer
    dim c as local integer
    c=(xb(fl(f,1))-xb(fl(f,0))) * (yb(fl(f,2))-yb(fl(f,0))) - (yb(fl(f,1))-yb(fl(f,0))) * (xb(fl(f,2))-xb(fl(f,0)))

    if c>0 then
    	InFront%=0
    else
    	InFront%=&HFFFF
    end if

end function

'sort all shaps (z-positon)
sub SortPoly
    dim i 		as local integer
    dim z 		as local integer
    dim flag 	as local integer
    dim zm 		as local integer
    dim zm2 	as local integer
    dim f 		as local integer

	for i=0 to %fa

    	fs(i)=i
    next
    sortrun:
    flag=0
	for f=0 to %fa-1
    	zm=0:zm2=0
    	for z=0 to 3
       		zm =zm +zr(fl(fs(f)  ,z))
           	zm2=zm2+zr(fl(fs(f+1),z))
       	next
       	zm=zm\4:zm2=zm2\4
       	if zm>zm2 then flag=1:swap fs(f),fs(f+1)
    next
    if flag then sortrun
end sub

'create the flotingpoint values of sinus and cosinus
sub WinkelTab
	dim w as local single
    dim z as local integer

    for w!=0 to 6.28 step 6.28 / 359
    	co!(z)=cos(w!)
        si!(z)=sin(w!)
        incr z
    next
end sub
